#if 0
putchar(int ch)
{
  long a1,a2,v0;
  __asm__ __volatile__ (
       "move %1,$5\n\t"
       "move %2,$6\n\t"
       "move %3,$2\n\t"
       "addiu $29,$29,-8\n\t"
       "sb   %0,0($29)\n\t"
       "move $5,$29\n\t"
       "ori  $6,$0,1\n\t"
       "ori  $2,$0,0xfa4\n\t"
       "syscall\n\t"
       "addiu $29,$29,8\n\t"
       "move $5,%1\n\t"
       "move $6,%2\n\t"
       "move $2,%3\n\t"
       : "=r" (ch), "=r" (a1), "=r" (a2), "=r" (v0)
       : "0" (ch), "1"  (a1), "2"  (a2),  "3"  (v0));
}
#else
putchar(int ch)
{
  __asm__ __volatile__ (
       "move $2,%0\n\t"
       "teq $0,$0\n\t"
       : "=r" (ch) : "0" (ch));
}
#endif

puts(char *str)
{
  while(*str){
    putchar(*str);
    str++;
  }
  putchar('\n');
}

static puts2(char *str)
{
  while(*str){
    putchar(*str);
    str++;
  }
}

static int fig(long a,int rad)
{
  if((a/rad)==0)
    return 1;
  return fig(a/rad,rad)+1;
}

static long iabs(long x)
{
  if(x<0)
    return -x;
  return x;
}

static long isgn(long x)
{
  if(x<0)
    return 1;
  return 0;
}

static void put_ni(int width,int right,int sp,int up,int rad, int sgn, long a)
{
  if((width<=0)&&(a==0)){
    putchar('0');
    return;
  }
  else if(width<=0){
    if(sgn){
      putchar('-');
      sgn=0;
    }
    if((a/rad)!=0)
      put_ni(width,right,sp,up,rad,sgn,a/rad);
    if(rad==10){
#if 0
      putchar("0123456789"[a%rad]);
#else
      putchar((a%rad)+'0');
#endif
      return;
    }
    else if(up){
#if 0
      putchar("0123456789ABCDEF"[a%rad]);
#else
      if((a%rad)<10)
        putchar((a%rad)+'0');
      else
        putchar((a%rad)-10+'A');
#endif
      return;
    }
    else {
#if 0
      putchar("0123456789abcdef"[a%rad]);
#else
      if((a%rad)<10)
        putchar((a%rad)+'0');
      else
        putchar((a%rad)-10+'a');
#endif
      return;
    }
  }
  else{ /* width>0 */
    if(right){
      if(sgn){
        putchar('-');
        sgn=0;
      }
      put_ni(width-1,right,sp,up,rad,sgn,a);
      putchar(' ');
      return;
    }
    else{
      if((sp=='0')&&(sgn)){
        putchar('-');
        sgn=0;
      }
      putchar(sp);
      put_ni(width-1,right,sp,up,rad,sgn,a);
      return;
    }
  }
}

static int strlen(char *s)
{
  int n=0;
  while(*s){
    n++;
    s++;
  }
  return n;
}

static void put_ns(int width,int right,int sp,char *str)
{
  int n=strlen(str);
  int i;
  if(n>width)
    puts2(str);
  else{
    n=width-n;
    if(right){
      puts2(str);
      for(i=0;i<n;i++)
        putchar(' ');
    }
    else{
      for(i=0;i<n;i++)
        putchar(sp);
      puts2(str);
    }
  }
}

 double get_fav(int no)
{
   double r=0.0;
   switch(no){
   case 12:
     __asm__ __volatile__("mov.d %0,$f12" : "=f" (r) : "0" (r));
     break;
   case 13:
     __asm__ __volatile__("mov.d %0,$f13" : "=f" (r) : "0" (r));
     break;
   case 14:
     __asm__ __volatile__("mov.d %0,$f14" : "=f" (r) : "0" (r));
     break;
   case 15:
     __asm__ __volatile__("mov.d %0,$f15" : "=f" (r) : "0" (r));
     break;
   case 16:
     __asm__ __volatile__("mov.d %0,$f16" : "=f" (r) : "0" (r));
     break;
   }
   return r;
}

printf(char *fmt, long d0, long d1, long d2, long d3, long d4, long d5, long d6, 
       long d7, long d8, long d9)
{
  long a[10];
  int  right;
  int  width;
  int  frac;
  int  sp;
  int  ap;
  int  fap;
  double d;
  long  x,y;
  long  e;
  int   s;          
  int   i;
  char c[2];
  a[0] = d0;
  a[1] = d1;
  a[2] = d2;
  a[3] = d3;
  a[4] = d4;
  a[5] = d5;
  a[6] = d6;
  a[7] = d7;
  a[8] = d8;
  a[9] = d9;
  ap   = 0;
  fap  = 0;
  while(1){
    while((*fmt!=0)&&(*fmt!='%')){
      putchar(*fmt);
      fmt++;
    }
    if(*fmt==0)
      break;
    fmt++;
    right = 0;
    width = 0;
    frac  = 6;
    sp    = ' ';
    if(*fmt=='%'){
      putchar('%');
      fmt++;
    }
    else {
      if(*fmt=='-'){
        right = 1;
        fmt++;
      }
      if(*fmt=='0'){
        sp = '0';
        fmt++;
      }
      if((*fmt>='1')&&(*fmt<='9')){
        while((*fmt>='0')&&(*fmt<='9')){
           width = width*10 + (*fmt-'0');
           fmt++;
        }
      }
      if(*fmt=='.'){
        frac = 0;
	fmt++;
        while((*fmt>='0')&&(*fmt<='9')){
           frac = frac*10 + (*fmt-'0');
           fmt++;
        }
        if(frac>9)
          frac = 9;
      }
      if(*fmt=='l'){  /* for %lf %ld */
        fmt++;        /* ignore */
      }
      switch(*fmt){
      case 'd':
        put_ni(width-fig(a[ap],10)-isgn(a[ap]),right,sp,0,10,isgn(a[ap]),iabs(a[ap]));
        ap++;
        break;
      case 'x':
        put_ni(width-fig(a[ap],16)-isgn(a[ap]),right,sp,0,16,isgn(a[ap]),iabs(a[ap]));
        ap++;
        break;
      case 'X':
        put_ni(width-fig(a[ap],16)-isgn(a[ap]),right,sp,1,16,isgn(a[ap]),iabs(a[ap]));
        ap++;
        break;
      case 's':
        put_ns(width,right,sp,(char*)a[ap]);
        ap++;
        break;
      case 'c':
        c[0] = a[ap];
        c[1] = 0;	
        put_ns(width,right,sp,c);
        ap++;
        break;
      case 'f':
        d = get_fav(fap+12);
        fap++;
        s = 0;
        if(d<0){
          s = 1;
          d = -d;
        }
        x = (long)d;
        if(frac==0){
          put_ni(width-fig(x,10)-s,right,sp,0,10,s,x);
        }
        else{
          d = d - (double)x;
          for(i=1;i<=frac;i++)
            d = d*10.0;
          y = (long)d;
          put_ni(width-fig(x,10)-frac-1-s,right,sp,0,10,s,x);
          putchar('.');
          put_ni(0,right,sp,0,10,0,y);
        }
        break;
      case 'e':
        d = get_fav(fap+12);
        fap++;
        s = 0;
        if(d<0.0){
          s = 1;
          d = -d;
        }
        e = 0;
        if(d==0.0){
          x = 0;
          y = 0;
        }
        else if(d<1.0){
          while(1){
            x = (long)d;
            if((x>=1)&&(x<=9))
              break;
            d = d*10.0;
            e--;
          }
          d = d - (double)x;
          for(i=1;i<=frac;i++)
            d = d*10.0;
          y = (long)d;
        }
        else{
          while(1){
            x = (long)d;
            if((x>=1)&&(x<=9))
              break;
            d = d/10.0;
            e++;
          }
          d = d - (double)x;
          for(i=1;i<=frac;i++)
            d = d*10.0;
          y = (long)d;
        }
        put_ni(width-fig(x,10)-s-4,right,sp,0,10,s,x);
        putchar('.');
        if(y==0)
          put_ni(5,0,'0',0,10,0,y);
        else
          put_ni(0,0,'0',0,10,0,y);
        putchar('e');
        if(e<0){
          putchar('-');
          e = -e;
        }
        else{
          putchar('+');
        }
        put_ni(2-fig(e,10),0,'0',0,10,0,e);
        break;
      }
      fmt++;
    }
  }
}


