void * memset(void * s, int c, int count)
{
  void *xs = s;

  if (!count)
    return xs;
  __asm__ __volatile__(
        ".set\tnoreorder\n"
        "1:\tsb\t%3,(%0)\n\t"
        "bne\t%0,%1,1b\n\t"
        "addiu\t%0,%0,1\n\t"
        ".set\treorder"
        : "=r" (s), "=r" (count)
        : "0" (s), "r" (c), "1" (s + count - 1)
        : "memory");

  return xs;
}

